/* 
 * Tactic is the legal property of its developers, whose names are too numerous 
 * to list here.  Please refer to the COPYRIGHT file distributed with this 
 * source distribution. 
 * 
 * This library is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation; either 
 * version 2.1 of the License, or (at your option) any later version. 
 * 
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * Lesser General Public License for more details. 
 * 
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA 
 *
 * See README for more informations
 *
 * EnnemyHealthPoint.h
 *
 * This class is the poucentage of the hp of the ennemy group 
 *
 * Date 19/03/06
 *
 */

#include "EnnemyHealthPoint.h"

using namespace std;
	
EnnemyHealthPoint::EnnemyHealthPoint(void){
	name = ENNEMY_HEALTH_POINT;
}

EnnemyHealthPoint::EnnemyHealthPoint(vector<FuzzyValue*> vect){
	name = ENNEMY_HEALTH_POINT;
	this->setVect(vect);
}

EnnemyHealthPoint::EnnemyHealthPoint(HPHigh* fv1, HPMiddle* fv2, HPLow* fv3){
	name = ENNEMY_HEALTH_POINT;
	vector<FuzzyValue*> vect = vector<FuzzyValue*>();
	vect.push_back(fv1);
	vect.push_back(fv2);
	vect.push_back(fv3);
	this->setVect(vect);
}

EnnemyHealthPoint::~EnnemyHealthPoint(void){}

void EnnemyHealthPoint::update(void){
	// à voir
	int hp = ennemy->getHP();
	if(hp < 0) hp = 0;
	int hpMax = ennemy->getHPMax();
	if (hpMax != 0){
		value = (float)hp/(float)hpMax;
	}else{
		value = EnnemyHealthPoint::infinite;
	}
	value = value * 100;
	notify();
	DebugAI::trace('n', "Ennemy HP = " + Converter::floatToString(ennemy->getHP()));
	DebugAI::trace('n', "Ennemy HPMax = " + Converter::floatToString(ennemy->getHPMax()));
	DebugAI::trace('n', toString());
}

void EnnemyHealthPoint::setEnnemy(GroupEnnemy* ennemy){
	this->ennemy = ennemy;
}
